<template>
  <div class="register-page">
    <div class="register">
      <form @submit.prevent="submit" class="form">
        <span class="title">
          <span>*</span>
          First Name
        </span>
        <input v-model="formData.firstName.value" type="text" class="input">

        <span class="title">
          <span>*</span>
          Last Name
        </span>
        <input v-model="formData.lastName.value" type="text" class="input">

        <span class="title">
          <span>*</span>
          Login
        </span>
        <input v-model="formData.login.value" type="text" class="input">

        <span class="title">
          <span>*</span>
          Email
        </span>
        <input v-model="formData.email.value" type="text" class="input">

        <span class="title">
          <span>*</span>
          Telephone
        </span>
        <input v-model="formData.telephone.value" type="number" class="input">

        <span class="title">
          <span>*</span>
          Password
        </span>
        <input v-model="formData.password.value" type="password" class="input">

        <span class="title">
          <span>*</span>
          Confirm password
        </span>
        <input v-model="formData.confirmPassword.value" type="password" class="input">

        <div class="reg-btn-cont">
          <Spinner v-if="loading" :width="40" :height="40" />
          <input type="submit" class="register-button" value="Sign up">
        </div>
      </form>
      <div class="signin-title">Already have an account?</div>
      <div @click="$router.push('/login')" class="signin-btn rtrLnk">Log In</div>
    </div>
  </div>

</template>
<script>
import { mapGetters } from 'vuex'
import { PROFILE, MODAL } from '../store/types'
import Spinner from '@/components/Spinner'
export default {
  name: 'RegisterPage',
  components: {
    Spinner
  },
  data: () => ({
    formData: {
      firstName: {
        value: '',
        error: null
      },
      lastName: {
        value: '',
        error: null
      },
      login: {
        value: '',
        error: null
      },
      email: {
        value: '',
        error: null
      },
      telephone: {
        value: '',
        error: null
      },
      password: {
        value: '',
        error: null
      },
      confirmPassword: {
        value: '',
        error: null
      }
    }
  }),
  computed: {
    ...mapGetters({
      loading: PROFILE.GETTER.GET_REGISTER_LOADING
    })
  },
  watch: {
    'formData.telephone.value': function (ch) {
      console.log('ch', ch)
      console.log('test', /'^\+?77([0124567][0-8]\d{7})$'/g.test(ch))
      if (!/'^\+?77([0124567][0-8]\d{7})$'/.test(ch)) {
        ch.slice(0, -1)
      }
    }
  },
  methods: {
    async submit () {
      console.log('submitting')
      const formData = this.formData
      if (formData.confirmPassword.value !== formData.password.value) {
        formData.confirmPassword.error = `Passwords don't match`
        formData.password.error = `Passwords don't match`
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Passwords don't match`)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
        return
      }
      for (const field of Object.values(formData)) {
        let emptyFields = false
        if (!field.value) {
          field.error = 'This field cannot be empty'
          emptyFields = true
        }
        if (emptyFields) {
          this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Passwords don't match`)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
          return
        }
      }

      console.log('about')
      const result = await this.$store.dispatch(PROFILE.ACTION.REGISTER, {
        firstName: this.formData.firstName.value,
        lastName: this.formData.lastName.value,
        login: this.formData.login.value,
        email: this.formData.email.value,
        telephone: this.formData.telephone.value,
        password: this.formData.password.value
      })

      if (!result.error) this.$router.push(`/login`)
      else if (result.error) {
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Error on register: ${result.err}`)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
      }
    }
  }
}
</script>
<style lang="scss" scoped>
.register-page {
  display: flex;
  align-items: center;
  flex-direction: column;
}
.reg-btn-cont {
  position: relative;
}
.register {
  max-width: 356px;
  width: 100%;
  display: flex;
  flex-direction: column;
}

.form {
  width: 100%;
  display: flex;
  flex-direction: column;
  margin-bottom: 12px;

  & .title {
    margin-bottom: 8px;
    width: 100%;
    text-align: start;
    & span {
      color: red;
    }
  }

  & .input {
    width: 100%;
    height: 32px;
    border: 1px solid rgba(0, 0, 0, 0.15);
    box-sizing: border-box;
    border-radius: 4px;
    margin-bottom: 13px;
  }

  & .register-button {
    background: #1890FF;
    border: 1px solid #1890FF;
    box-sizing: border-box;
    border-radius: 5px;
    color: white;
    height: 48px;
    font-family: $base_font;
    font-size: 18px;
    cursor: pointer;
    transition: 0.3s;
    width: 100%;

    &:hover {
      opacity: 0.8;
    }
  }
}
.signin-title {
  font-family: $base_font;
  font-weight: normal;
  font-size: 14px;
  line-height: 22px;
  color: #3A3F45;
  text-align: start;
  margin-bottom: 3px;
}
.signin-btn {
  width: 100%;
  height: 48px;
  background: #FFFFFF;
  border: 1px solid #1890FF;
  box-sizing: border-box;
  border-radius: 5px;
  font-family: $base_font;
  font-size: 18px;
  color: #1890FF;
  cursor: pointer;
  transition: 0.3s;
  display: flex;
  align-items: center;
  justify-content: center;
  &:hover {
    opacity: 0.7;
  }
}
</style>
